CURLOPT_PROXY_SSLVERSION(3) Library Functions Manual CURLOPT_PROXY_SSLVERSION(3)

CURLOPT_PROXY_SSLVERSION - preferred HTTPS proxy TLS version

#include <curl/curl.h>
CURLcode curl_easy_setopt(CURL *handle, CURLOPT_PROXY_SSLVERSION,
                          long version);

Pass a long as parameter to control which version of SSL/TLS to attempt to use when connecting to an HTTPS proxy.

Use one of the available defines for this purpose. The available options are:

The default action. This attempts to figure out the remote SSL protocol version.
TLSv1.x
TLSv1.0
TLSv1.1
TLSv1.2
TLSv1.3 The maximum TLS version can be set by using one of the CURL_SSLVERSION_MAX_ macros below. It is also possible to OR one of the CURL_SSLVERSION_ macros with one of the CURL_SSLVERSION_MAX_ macros. The MAX macros are not supported for WolfSSL.
The flag defines the maximum supported TLS version as TLSv1.2, or the default value from the SSL library. (Added in 7.54.0)
The flag defines maximum supported TLS version as TLSv1.0. (Added in 7.54.0)
The flag defines maximum supported TLS version as TLSv1.1. (Added in 7.54.0)
The flag defines maximum supported TLS version as TLSv1.2. (Added in 7.54.0)
The flag defines maximum supported TLS version as TLSv1.3. (Added in 7.54.0)

In versions of curl prior to 7.54 the CURL_SSLVERSION_TLS options were documented to allow only the specified TLS version, but behavior was inconsistent depending on the TLS library.

CURL_SSLVERSION_DEFAULT

All TLS based protocols: HTTPS, FTPS, IMAPS, POP3S, SMTPS etc.

All TLS backends support this option.

int main(void)
{
  CURL *curl = curl_easy_init();
  if(curl) {
    curl_easy_setopt(curl, CURLOPT_URL, "https://example.com");
    /* ask libcurl to use TLS version 1.0 or later */
    curl_easy_setopt(curl, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1);
    /* Perform the request */
    curl_easy_perform(curl);
  }
}

Added in 7.52.0

Returns CURLE_OK if the option is supported, and CURLE_UNKNOWN_OPTION if not.

CURLOPT_HTTP_VERSION(3), CURLOPT_IPRESOLVE(3), CURLOPT_SSLVERSION(3), CURLOPT_USE_SSL(3)

2024-05-22 libcurl